/* Lists all system restore points stored on a computer, as well as detailed information about each of those restore points */
dtmConvertedDate = CreateComObject("WbemScripting.SWbemDateTime")
strComputer = "."
objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" || strComputer || "\root\default")
colItems = objWMIService~ExecQuery("Select * from SystemRestore")
IF colItems~Count = 0 THEN
	SAY "No restore point in system."
ELSE DO objItem OVER colItems
	SAY "Name:" objItem~Description
	SAY "Number:" objItem~SequenceNumber
        SELECT objItem~RestorePointType
		WHEN 0 THEN strRestoreType = "Application installation"
		WHEN 1 THEN strRestoreType = "Application uninstall"
		WHEN 6 THEN strRestoreType = "Restore"
		WHEN 7 THEN strRestoreType = "Checkpoint"
		WHEN 10 THEN strRestoreType = "Device drive installation"
		WHEN 11 THEN strRestoreType = "First run"
		WHEN 12 THEN strRestoreType = "Modify settings"
		WHEN 13 THEN strRestoreType = "Cancelled operation"
		WHEN 14 THEN strRestoreType = "Backup recovery"
		OTHERWISE strRestoreType = "Unknown"
        END
	SAY "Restore Point Type:" strRestoreType
	dtmConvertedDate~Value = objItem~CreationTime
	SAY "Time:" dtmConvertedDate~GetVarDate()
END

